#ifndef MERGER_H
#define MERGER_H
#include "color.h"
#include <algorithm>
#include <hash_set.h>
#include "datastruct.h"
#include "summarizer.h"
//#include <math.h>

typedef hash_set<UINT> ColorSet;

void printColorSet(ColorSet& cs);

void printColorSets(vector<ColorSet> vcs);
class Merger
{
public:
	//merge two existing colors, c1 < c2
	void mergeColor(UINT c1, UINT c2);
	
	void printColorArr();
	void mergeGroups(int k, Summarizer* psmr);
	int getDelta();
	void Sort(vector<int>& num);

	Merger(ColorArray* parr, ColorArray* orgarr, bool directedGraph);
	~Merger();
private:
	MinHeap<GroupDistance, ColorEdge, colorEdgehash, eqColorEdge>* heap;
	vector<ColorSet> initColorSets;
	ColorArray* p_colorArr;
	ColorArray* f_colorArr;
	bool directed;
	vector<ELEM<GroupDistance, ColorEdge> >* h;
	vector<ELEM<float, ColorEdge> >* deltarecord;
	MinHeap<float, ColorEdge, colorEdgehash, eqColorEdge>* cutoff;
};
#endif

