#ifndef SUMMERIZER_H
#define SUMMERIZER_H

#include "color.h"
#include <algorithm>
#include "datastruct.h"
#include "../util/minheap.h"
#include <hash_set.h>
#include <queue>
#include <iomanip>
#include "../util/mytimer.h"
#include "../db/db.h"
#include <math.h>

class Summarizer
{
public:

	MicroTimer timer;
	double time;
	~Summarizer();
	
	Summarizer(DB* pdb)
	{
		timer.reset();
		time=0;
		db=pdb;
		neighborplan=false;
	}
	
	void setGraph(string prefix, int g, string attrname, string edgetype)
	{
		tablePrefix=prefix;
		Color::gid=g;
		Color::edgeType=edgetype;
		Color::nodeAttr=attrname;
		Color::maxColorid=-1;
		
		groupByAttribute();
		
		char qrystr[500];
		neighborplan=true;
		sprintf(qrystr, "prepare %s_neighborplan (int4, int4) as select nodeID from "
				"( (select node2ID as nodeID from %s_edge where attrname=\'type\' "
				"and attrvalue=\'%s\' and graphID=$1 and node1ID=$2) union "
				"(select node1ID as nodeID from %s_edge where attrname=\'type\' "
				"and attrvalue=\'%s\' and graphID=$1 and node2ID=$2) ) t;", 
				tablePrefix.c_str(), tablePrefix.c_str(), edgetype.c_str(), 
				tablePrefix.c_str(), edgetype.c_str());
		db->preparePlan(string(qrystr));
	}
	void groupByAttribute();
	void intializeColorArray(UINT*& nodeColorMap);
	void initializePaticipates(UINT* nodeColorMap);

	DB* db;
	ColorArray colorArr;
	ColorArray origin_colorArr;
	bool directedGraph;
private:
	string tablePrefix;
	bool neighborplan;
	
};

#endif
