#include "config.h"
#include "util/util.h"
#include<iostream>
#include<cstdlib> // for atoi
#include <iostream>

Config::Config()
{
	dbname="SAGA";
//	tablePrefix="";
//	dbuser="postgres";
	frag_size=3;
	dmax=3;
//	orth_file_name ="ko.list";
	we=1.0;
	wn=1.0;
	wg=1.0;
	gap_cost=3.0;
	max_pair_dist=3;
}

void Config::readFile(char* filename)
{

	if(filename=="")
	{
		cout<<"No configuration is given, using default values for configuration parameters instead!\n";
		return;
	}
		
 	// eat any empty lines, and comments.
    	// comments have an # in the first column
    	std::ifstream file(filename);
	if(!file.is_open())
	{
		cout<<"Can not read file "<<filename<<", using default values for configuration parameters instead!\n";
		return;
	}
	std::string in;
    	while(std::getline(file, in)) 
	{
        	// check if it's an empty line or comment
        	if (in == "" || in[0]=='#')	continue;
       		else // else, treat it like a value to set.
		{
			unsigned pos = in.find_first_of("#");
			if(pos>0)
				in=in.substr(0, pos);
			pos = in.find_first_of("=");
			if(pos<0)
			{
				cout<<"Ignored unrecognizable  configuration format "<<in<<"\n";
				continue;				
			}
			std::string var = in.substr(0, pos);
            		std::string val = in.substr(pos+1, std::string::npos);
            		setConfigVars(trimStr(var), trimStr(val)); 
		}
	}
}

void Config::setConfigVars(const std::string& var,  const std::string& val)
{
    if (var == "DB_NAME") {
        dbname = val;
    }
   // else if(var == "TABLE_PREFIX") {
   //     tablePrefix=val;
   // }
    else if (var == "FRAGMENT_SIZE") {
        frag_size = atoi(val.c_str());
    }
    else if (var == "D_MAX") {
        dmax = atoi(val.c_str());
    }
    else if (var == "WE") {
	we = atof(val.c_str());
    }
    else if (var == "WN") {
	wn = atof(val.c_str());
    }
    else if (var == "WG") {
	wg = atof(val.c_str());
    }
    else if (var == "SINGLE_GAP_COST") {
	gap_cost = atof(val.c_str());
    }
    else if (var == "MAX_PAIR_DIST") {
	max_pair_dist = atoi(val.c_str());
    }
 //   else if (var == "ORTHLOGY_FILE_NAME")
  //  {
  //  	orth_file_name=val;
  //  }
    else if(var == "DB_USER")
    {
    	dbuser=val;
    }
    else if(var == "DB_PWD")
    {
    	dbpwd=val;
    }
    else if(var == "TEMP_DIR")
    {
    	tempdir=val;
    }
    else
    {
    	cout<<"Ignored unrecognizable  parameter "<<var<<"\n";		
    }
}

void Config::printConfig()
{
	cout<<"DB_NAME = "<<dbname<<endl;
//	cout<<"TABLE_PREFIX = "<<tablePrefix<<endl;
	cout<<"DB_USER = "<<dbuser<<endl;
	cout<<"DB_PWD = "<<dbpwd<<endl;
	cout<<"FRAGMENT_SIZE = "<<frag_size<<endl;
	cout<<"D_MAX = "<<dmax<<endl;
//	cout<<"ORTHLOGY_FILE_NAME = "<<orth_file_name<<endl;
	cout<<"WE = "<<we<<endl;
	cout<<"WN = "<<wn<<endl;
	cout<<"WG = "<<wg<<endl;
	cout<<"SINGLE_GAP_COST = "<<gap_cost<<endl;
	cout<<"MAX_PAIR_DIST = "<<max_pair_dist<<endl;
	cout<<"TMEP_DIR = "<<tempdir<<endl;
}
