/*******************************************************************/
//Provies an interface to read different parameter settings from a configuration file.
//NOTE: this version only works for graphs without edge weight
/*******************************************************************/

#ifndef ConfigFile_h
#define ConfigFile_h

#include<string>
#include<fstream>
using namespace std;
class Config
{
	public:
	//method
	Config();
	void readFile(char* filename);
	void setConfigVars(const std::string& var,  const std::string& val);
        void printConfig();
	//data
	string dbname;
	string dbuser;
	string dbpwd;
	//string tablePrefix;
	int frag_size;
	int dmax;
	//string orth_file_name;
	float we;
	float wn;
	float wg;
	float gap_cost;
	int max_pair_dist;
	string tempdir;
};

#endif // ConfigFile_h

