#include "gdf.h"
#include "../util/util.h"

void writeGDFAttribute(
		ostream& s,	//output in GDF format
		string attrname, //attribute to write
		char attrtype //type of the attribute
		)
{
	s<<","<<attrname;
	//first handle the predefined attributes
	if(attrname=="name" || attrname=="label" || attrname=="image" || attrname=="color" 
		|| attrname=="node1" || attrname=="node2" || attrname=="x" || attrname=="y"
		|| attrname=="width" || attrname=="height"  || attrname=="weight" || attrname=="visible"
		|| attrname=="fixed" || attrname=="labelvisible" || attrname=="directed" || attrname=="style")
		return;
	
	string typestr;
	switch(attrtype)
	{
	case('i'):
		typestr="int";
		break;
	case('f'):
		typestr="float";
		break;
	case('b'):
		typestr="boolean";
		break;
	case('s'):
		typestr="varchar";
		break;
	case('c'):
		typestr="char";
		break;
	default:
		assert(false);
	};
	s<<" "<<typestr;
}

void parseGDFAttribute(string seg, string& name, char& type, string& defvalue)
{
	debug(31, "parse attribute: "<<seg<<endl);
	//first handle the predefined attributes
	if(seg=="name" || seg=="label" || seg=="image" || seg=="color" || seg=="node1" || seg=="node2")
	{
		name=seg;
		type='s';
	}else if(seg=="x" || seg=="y" || seg=="width" || seg=="height" || seg=="weight")
	{
		name=seg;
		type='f';
	}else if(seg=="visible" || seg=="fixed" || seg=="labelvisible" || seg=="directed")
	{
		name=seg;
		type='b';
	}else if(seg=="style")
	{
		name=seg;
		type='i';
	}else
	{
		int start=0;
		
		//get name
		start=getOneSegment(seg, start, ' ', name);
		assert(start!=string::npos);
		debug(31, "attribute name: "<<name<<endl);
		//get type
		string typestr;
		start=getOneSegment(seg, start, ' ', typestr);
		typestr=tolower(typestr);
		debug(31, "attribute type: "<<typestr<<endl);
		if(typestr=="int")
			type='i';
		else if(typestr=="double" || typestr=="float")
			type='f';
		else if(typestr=="boolean")
			type='b';
		else if(typestr.substr(0, 7)=="varchar")
			type='s';
		else
			assert(false);
		
		defvalue="";
		
		if(start==string::npos)
			return;
		
		//get default value
		if(start!=string::npos)
		{
			start=getOneSegment(seg, start, ' ', defvalue);
			defvalue=tolower(typestr);
			assert(defvalue=="default" && start!=string::npos);
			start=getOneSegment(seg, start, ' ', defvalue);
			
			debug(31, "attribute value: "<<defvalue<<endl);
		}
	}
}
