#ifndef GRAPHIO_H
#define GRAPHIO_H

#include "../graph/hashgraph.h"
#include <set>
#include "../orthology/ortholog.h"
#include <hash_set.h>
#include <iostream>
#include "gdf.h"

HashGraph* readGraphSAGAFormat(
		FILE* f,	//input file in SAGA graph format
		Ortholog& orth,	//ortholog name to ortholog id mapping
		OrthologInfoList& orthinfolist	//return value, the orthology info
		);

HashGraph* readGraphGDFFormat(
		FILE* f,	//input file in GDF format
		string gname, //the input graph name
		Ortholog& orth,	//ortholog name to ortholog id mapping
		OrthologInfoList& orthinfolist,	//return value, the orthology info
		bool directed  //if the graph is directed or not
		);

HashGraph* createGraphFromDB(
		DB* db,	//the database from where the graph is read from
		string tablePrefix,	//the prefix of tables in the database
		int graphID,	//the graphID of the graph in the database	
		string nodeCondition, //the condition on node table
		string edgeCondition, //the condition on edge table
		OrthologInfoList& orthinfolist  //return value, the orthology info
		);

HashGraph* readGraphFromDB(
		DB* db,	//the database from where the graph is read from
		string tablePrefix,	//the prefix of tables in the database
		int graphID,	//the graphID of the graph in the database	
		OrthologInfoList& orthinfolist  //return value, the orthology info
		);
//assume that all the nodes have the same attributes
//assume that all the edges have the same attributes
void writeGraphGDFFormat(
		ostream& s,	//output in GDF format
		HashGraph* G, //input graph
		Ortholog& orth,	//ortholog name to ortholog id mapping
		OrthologInfoList& orthinfolist	//the orthology info
		);
#endif
