/******************************************************************************
 * The defination of fuctions and types related to the orthology information
 * of nodes. 
 * Author: Yuanyuan Tian (ytian@umich.edu)
 * ***************************************************************************/
#include "ortholog.h"
#include "../util/util.h"

//the function that takes the file of ortholog names and build
//the ortholog hash map
void Ortholog::buildOrthologMap(FILE* f)
{
	string key;
	int value=1;
	while(readOneLine(f, key))
	{
		n2idmap.insert(OrthologName2IDMap::value_type(key, value));
		id2nmap.insert(OrthologID2NameMap::value_type(value, key));
		value++;
	}
}

//given a ortholog name key, find the ortholog id
uint32_t Ortholog::getOrthologID(string name)
{ 
	if(name=="none")
		return 0;
	OrthologName2IDMap::iterator iter=n2idmap.find(name);
	if(iter==n2idmap.end())
		return 0;
	else
		return iter->second;
}

string Ortholog::getOrthologName(uint32_t id)
{
	OrthologID2NameMap::iterator iter=id2nmap.find(id);
	if(iter==id2nmap.end())
		return "none";
	else
		return iter->second;
}

//the less than comparison of Vertex_Ortholog based on the orthologous id
//used to group all the probes by the ortholog ids
bool ltNO(const NodeOrtholog vo1, const NodeOrtholog vo2)
{
	return vo1.orthID<vo2.orthID;
}
