#ifndef COLOREDGE_H
#define COLOREDGE_H
#include <string>
#include <iostream>
#include <hash_set.h>
#include <hash_map.h>
#include "../util/util.h"
using namespace std;

typedef unsigned int UINT;
struct ColorEdge
{
	friend ostream& operator<<(ostream& output, const ColorEdge& ce)
	{
		output << "(" << ce.colorid1  << ", " << ce.colorid2 <<")";
		return output;  // for multiple << operators.
	}
	int colorid1;
	int colorid2;
};

struct eqColorEdge
{
  bool operator()(const ColorEdge ce1, const ColorEdge ce2) const
  {
    return  ((ce1.colorid1==ce2.colorid1)&&(ce1.colorid2==ce2.colorid2));
  }
};

struct colorEdgehash
{
	int operator() (const ColorEdge ce) const
	{
		int key= ce.colorid1|ce.colorid2;
		return hashfunc(key)%32749;
	}
};

struct GroupDistance
{
	friend ostream& operator<<(ostream& output, const GroupDistance& gd)
	{
		output<<"freqDist = "<<gd.freqDist<<", minusNumAgree = "<<gd.minusNumAgree
			<<", minGroupSize = "<<gd.minGroupSize;
		return output;  // for multiple << operators.
	}
	float freqDist; //smaller the better
	int minusNumAgree; //the minus of the number of agreed frequencies, the smaller the bettwer
	int minGroupSize; // the minimum size of the two groups, the smaller the better
};

bool operator < (const GroupDistance& d1, const GroupDistance& d2);

bool operator > (const GroupDistance& d1, const GroupDistance& d2);

bool operator == (const GroupDistance& d1, const GroupDistance& d2);

bool operator <= (const GroupDistance& d1, const GroupDistance& d2);

bool operator >= (const GroupDistance& d1, const GroupDistance& d2);

#endif
