#include "graph/hashgraph.h"
#include "io/graphio.h"

int main(int argc, char** argv) 
{
	if (argc != 3) {
		cout << "Usage: testio <query file> <orthlogy file>\n";
	exit(-1);
	}
	FILE* fin=fopen(argv[1], "r");
	if(!fin)
	{
	   cout << "Unable to open file |" << argv[1] << "|\n";
	   exit(-1);
	}
	
	FILE* orthf=NULL;
	
	orthf=fopen(argv[2], "r");
	if(!orthf)
	{
	   cout << "Unable to open file |" << argv[2] << "|\n";
	   exit(-1);
	}
	
	Ortholog orth;
	orth.buildOrthologMap(orthf);
		
	HashGraph* G;
	OrthologInfoList orthinfolist;
	
	while((G=readGraphSAGAFormat(fin, orth, orthinfolist))!=NULL)
	//while((G=readGraphGDFFormat(fin, "test", orth, orthinfolist))!=NULL)
	{
		//cout<<"graph size: "<<G->n()<<", "<<G->e()<<endl;
		writeGraphGDFFormat(cout, G, orth, orthinfolist);
		delete G; G=NULL;
		//debug(26, "safe here 2\n");
	}
	if(fin)
		fclose(fin);
	if(orthf!=NULL)
		fclose(orthf);
	return 0;
}

