/******************************************************************************
 * Definition for types and functions related to a distance matrix
 * Author: Yuanyuan Tian (ytian@umich.edu)
 * ***************************************************************************/
#include "matrix.h"
#include <cmath>

int getMatrixSum(Matrix& matrix)
{
	int sum=0;
	for(unsigned int i=0; i<matrix.size(); i++)
		sum+=matrix[i];
	return sum;
}
//given two summary get graph distance
//getDistance
// dist is the true return value, the distance between the two fragments,
//the function returns true if every pairwise difference is not greater than threshold.
bool getStructDist(Matrix& qm, Matrix& dbm, int threshold, int& dist)
{
	dist=0;
	assert(qm.size()==dbm.size());
	int temp;
	for(unsigned int i=0; i<qm.size(); i++)
	{
		temp=abs(qm[i]-dbm[i]);
		if(temp>threshold)
			return false;
		dist+=temp;
	}
	return true;
}

//return matrix and nodeset
void getMatrix(int** D, vector<NodeOrtholog>& vfset, Matrix& matrix, NodeSet& nset)
{
	for(unsigned int i=0; i<vfset.size(); i++)
	{
		nset.push_back(vfset[i].nodeID);
		for(unsigned int j=i+1; j<vfset.size(); j++)
		{
			matrix.push_back(D[vfset[i].nodeID][vfset[j].nodeID]);
		}
	}
}

